"""
 functions to match a bunch of fragment descriptors from a file

No user-servicable parts inside.  ;-)

"""
from __future__ import annotations
import os as os
from rdkit import Chem
from rdkit import RDConfig
__all__ = ['Chem', 'RDConfig', 'defaultPatternFileName', 'fn', 'fns', 'name', 'os']
def _CountMatches(mol, patt, unique = True):
    ...
def _LoadPatterns(fileName = None):
    ...
defaultPatternFileName: str = '/project/build/temp.linux-x86_64-cpython-310/rdkit_install/share/RDKit/Data/FragmentDescriptors.csv'
fn = None
fns: list  # value = [('fr_C_O', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6320>), ('fr_C_O_noCOO', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b63b0>), ('fr_Al_OH', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6440>), ('fr_Ar_OH', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b64d0>), ('fr_methoxy', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6560>), ('fr_oxime', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b65f0>), ('fr_ester', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6680>), ('fr_Al_COO', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6710>), ('fr_Ar_COO', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b67a0>), ('fr_COO', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6830>), ('fr_COO2', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b68c0>), ('fr_ketone', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6950>), ('fr_ether', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b69e0>), ('fr_phenol', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6a70>), ('fr_aldehyde', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6b00>), ('fr_quatN', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6b90>), ('fr_NH2', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6c20>), ('fr_NH1', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6cb0>), ('fr_NH0', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6d40>), ('fr_Ar_N', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6dd0>), ('fr_Ar_NH', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6e60>), ('fr_aniline', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6ef0>), ('fr_Imine', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b6f80>), ('fr_nitrile', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7010>), ('fr_hdrzine', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7130>), ('fr_hdrzone', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b70a0>), ('fr_nitroso', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b71c0>), ('fr_N_O', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7250>), ('fr_nitro', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b72e0>), ('fr_azo', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7370>), ('fr_diazo', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7400>), ('fr_azide', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7490>), ('fr_amide', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7520>), ('fr_priamide', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b75b0>), ('fr_amidine', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7640>), ('fr_guanido', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b76d0>), ('fr_Nhpyrrole', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7760>), ('fr_imide', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b77f0>), ('fr_isocyan', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7880>), ('fr_isothiocyan', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7910>), ('fr_thiocyan', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b79a0>), ('fr_halogen', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7a30>), ('fr_alkyl_halide', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7ac0>), ('fr_sulfide', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7b50>), ('fr_SH', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7be0>), ('fr_C_S', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7c70>), ('fr_sulfone', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7d00>), ('fr_sulfone', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7d90>), ('fr_sulfonamd', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7e20>), ('fr_prisulfonamd', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7eb0>), ('fr_barbitur', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58b7f40>), ('fr_urea', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec040>), ('fr_term_acetylene', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec0d0>), ('fr_imidazole', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec160>), ('fr_furan', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec1f0>), ('fr_thiophene', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec280>), ('fr_thiazole', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec310>), ('fr_oxazole', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec3a0>), ('fr_pyridine', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec430>), ('fr_piperdine', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec4c0>), ('fr_piperzine', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec550>), ('fr_morpholine', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec5e0>), ('fr_lactam', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec670>), ('fr_lactone', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec700>), ('fr_tetrazole', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec790>), ('fr_epoxide', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec820>), ('fr_unbrch_alkane', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec9d0>), ('fr_bicyclic', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ec8b0>), ('fr_benzene', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58eca60>), ('fr_phos_acid', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ecaf0>), ('fr_phos_ester', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ecb80>), ('fr_nitro_arom', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ecc10>), ('fr_nitro_arom_nonortho', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ecca0>), ('fr_dihydropyridine', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ecdc0>), ('fr_phenol_noOrthoHbond', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ecd30>), ('fr_Al_OH_noTert', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ece50>), ('fr_benzodiazepine', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ecee0>), ('fr_para_hydroxylation', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ecf70>), ('fr_allylic_oxid', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ed090>), ('fr_aryl_methyl', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ed000>), ('fr_Ndealkylation1', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ed120>), ('fr_Ndealkylation2', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ed1b0>), ('fr_alkyl_carbamate', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ed240>), ('fr_ketone_Topliss', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ed2d0>), ('fr_ArN', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ed360>), ('fr_HOCCN', <function _LoadPatterns.<locals>.<lambda> at 0x7fdcd58ed3f0>)]
name: str = 'fr_HOCCN'
